import astropy,os,scipy
import matplotlib.pyplot as plt
import numpy as np
from astropy.io import fits

xx=np.empty((16,100000))
yy=np.empty((16,100000))
cross=np.empty((16,16,100000))
num_all=np.zeros(16,dtype=int)

#os.system('ls p7103.0*.fits > fits.lst')
#os.system('ls k4m*_ori.fits > fits.lst')

for line in open("fits.lst"):
    line=line.strip("\n")
    object=fits.open(line)
    xxx=int(object[1].header['NAXIS1'])
    yyy=int(object[1].header['NAXIS2'])
    data=np.empty((16,yyy,xxx))

    obstype=object[0].header['OBSTYPE']
    print(line)

    if(obstype !='zero') and (obstype !='dome flat') and (obstype !='dark'):
        for n1 in range(4):
            for m1 in range(4):
                t1=n1*4+m1
#                print(object[t1+1].header['DATASEC'])
                os.system('sex '+line+'['+str(t1+1)+']')
                num=len(open('test.cat').readlines())-2

                f=open('test.cat')
                f.readline()
                f.readline()
                numx=-1
                for iii in range(num):
                    s=f.readline()
                    s=s.strip("\n")[2:]
                    arr=s.replace('=',' ').split()
#            arr=s.split('   ')
#            print arr
                    y=float(arr[0])
                    x=float(arr[1])
                
                    if (yyy-100.>x>100.) and (xxx-100.>y>100.):
                        numx=numx+1
                        xx[t1,numx]=arr[0]
                        yy[t1,numx]=arr[1]

                #print(num,numx)

                for n2 in range(4):
                    for m2 in range(4):
                        t2=n2*4+m2
                        data[t2,:yyy,:xxx]=object[t2+1].data[:yyy,:xxx]

                for n2 in range(4):
                    for m2 in range(4):
                        t2=n2*4+m2
                        for i in range(numx):
                            if(m1==0):
                                xc=xx[t1,i]
                                yc=yy[t1,i]
                            elif(m1==1):
                                xc=2064-(xx[t1,i]-3)
                                yc=yy[t1,i]
                            elif(m1==2):
                                xc=xx[t1,i]
                                yc=2095-(yy[t1,i]-18)
                            elif(m1==3):
                                xc=2064-(xx[t1,i]-3)
                                yc=2095-(yy[t1,i]-18)
                                
                            if(m2==0):
                                xc=xc
                                yc=yc
                            elif(m2==1):
                                xc=2064-(xc-3)
                                yc=yc
                            elif(m2==2):
                                xc=xc
                                yc=2095-(yc-18)
                            elif(m2==3):
                                xc=2064-(xc-3)
                                yc=2095-(yc-18)

#                            print(i,numx,xc,yc)
                            cross[t1,t2,i+num_all[t1]]=(np.mean(data[t2,int(yc)-2:int(yc)+2,int(xc)-2:int(xc)+2])-np.median(data[t2,int(yc)-50:int(yc)+50,int(xc)-50:int(xc)+50]))/np.mean(data[t1,int(yy[t1,i])-2:int(yy[t1,i])+2,int(xx[t1,i])-2:int(xx[t1,i])+2])
#                            if(t1+1==4):
#                                print(t2+1,xx[t1,i],yy[t1,i],xc,yc,np.mean(data[t2,int(yc)-2:int(yc)+2,int(xc)-2:int(xc)+2]),np.median(data[t2,int(yc)-50:int(yc)+50,int(xc)-50:int(xc)+50]),cross[t1,t2,i+num_all[t1]])

                num_all[t1]=num_all[t1]+numx
#                print(t1,num_all[t1])
#            print(k+1,round(np.median(cross[k,:num]),5))#,round(np.mean(cross[k,:num]),5)
    object.close()

#    for n in range(16):    
#        print('%.5f' % cross[0,n,10])

#print(cross[4,2,:num_all[4]])
#print(num_all,np.std(cross[4,2,:num_all[4]]))

fig = plt.figure()
for i in range(4):
    for j in range(4):
        ax=fig.add_subplot(4,4,i*4+j+1)

        temp=cross[i+4,j+4,:num_all[i]]*-1000.
        plt.hist(temp, bins=80, normed=1, color='b', range=(-2,6),alpha=0.5)

        plt.axis([-2,6,0,1.2])
#    plt.xlabel('') 
#    plt.ylabel('Num (normalized)')
#    plt.title('Histogram of Crosstalk')
plt.savefig('crosstalk',dpi=300)
plt.close('all')

for n in range(16):
    print('HDU ',n+1)
    for k in range(16):
        x=-1.*np.median(cross[k,n,:num_all[k]])
        y=np.std(cross[k,n,:num_all[k]])
        if (x<-0.01):
            x=0.
        print('%.5f' % x ,end=' ')
#        print('%.5f' % y ,end=' ')
    print()
